//Adapted C++ Meta Prog, Non Modern Compiler, D greater than Zero 0, Q0 not equal 0, for initial conditions PQa. 
//C++ 17 and C++20 constexpr would be easier and short compiler. But for purpose of unpacking
//constexpr code, to determine 'inline' with parameter number is an integral constant.
//For such as co-joining Equations with Quantum Entanglement. Given recursion depth 2^22.
//Then for the beginner.
#include <iostream>
#include <iterator>

struct false_type
{
    typedef false_type type;
    enum { value = 0 };
};

struct true_type
{
    typedef true_type type;
    enum { value = 1 };
};
template<bool condition, class T, class U>
struct if_
{
    typedef U type;
};

template <class T, class U>
struct if_<true, T, U>
{
    typedef T type;
};
//D > 0
template<size_t D>
struct is_PQa_D_impl
{
    typedef typename if_<(D > 0),
        true_type,
        typename if_<(D <= 0),
        false_type,
        is_PQa_D_impl<D> >::type >::type type;
    enum { value = type::value };
};
template<size_t D>
struct is_PQa_D
{
    enum { value = is_PQa_D_impl<D>::type::value };
};
// Q0 not equal zero
template<size_t Q0>
struct is_PQa_Q0_impl
{
    typedef typename if_<(Q0 != 0),
        true_type,
        typename if_<(Q0 == 0),
        false_type,
        is_PQa_Q0_impl<Q0> >::type >::type type;
    enum { value = type::value };
};
template<size_t Q0>
struct is_PQa_Q0
{
    enum { value = is_PQa_Q0_impl<Q0>::type::value };
};

int main()
{
    std::cout << is_PQa_D<13>::value << std::endl;
    std::cout << is_PQa_Q0<0>::value << std::endl;
}
